Description

The new dual view mode for the refreshed attribute table is really exciting stuff. That said, I think the user experience could be improved.

The clicking on pen vs string is IMO overly complicated and will lead people to wrongly conclude the dual view is broken when clicking on

string and seeing nothing happens.

What about offering a simplified interaction:

- If the user selects one item, the right-side area shows the attribute data form

- If the user selects more than one item, the right side area shows a grayed-out string that says something along the lines of "select one

item to view / edit its attribute data".

Gone is the pen, simplified is the experience, that should make users happy : )

History

#1 - 2013-04-02 03:36 AM - Matthias Kuhn

- Status changed from Open to Feedback

With your suggested approach, the user would loose any information about feature selection.

Or you would link feature selection and item editing, which makes you loose your selection every time you change the edit selection.

One thing we've been discussing was to change the pen to some sort of "selection icon" and use the list selection (blue background here, depends on your

system style) for editing.

Selecting multiple features and "mass-edit" their attributes is something that I hope I'll be able to implement in the future.

#2 - 2013-04-02 09:48 PM - Mathieu Pellerin - nIRV

Matthias,

IMO, the biggest counter-intuitiveness with the current implementation is that it defies a super basic user expectation: if I simply click on an item, I should

see something on the right-side panel. That's a behavior that matches many, many applications out there :)

So maybe a refined implementation as follow:

- If the user selects one row, that row shows up in the right-side attribute panel, and the row's pen button is activated

- If the user selects additional row(s), the right-side attribute panel stays open to the first selected item, and the user knows about that since the pen button

is indicating which row is open in the right-side panel

- The user can still edit other rows without affecting the selection by clicking on the pen button.
- IMO, the simple single click on a row (no shift, ctrl keys used) should always lead to right side panel showing up row's attributes (i.e. activate the pen

button); that's a user expectation that will confuse many if not fulfilled.

Also, I think always using the pen logo is a problem. I could use many users using the dual view not only to edit, but to also view attribute data. As such, the

pen logo is a bit misleading in view mode. Maybe the button should show an eye logo when the layer isn't in edit mode, and a pen when it is in edit mode?

#3 - 2013-04-02 09:58 PM - Mathieu Pellerin - nIRV

Matthias,

Indeed, turning the pen button into a selection state switch would probably be even nicer : ) It could be a simple check box. If that's implemented, then for

the sake of consistency it might be worth introducing these check boxes in the single table-based view too (i.e. first column being check box).

M

#4 - 2013-04-03 02:50 AM - Regis Haubourg

Agreed with turning the pen button into a selection state. There is a confusion with global editing pen button and same icon used for rows.

#5 - 2013-04-03 02:53 AM - Regis Haubourg

- File layout_attribute_table.jpg added

Another little minor improvement here. In Windows 7 style, a 1 px margin on top of toolbar misses. See file joined. 

Need a ticket for this?

#6 - 2013-04-08 06:43 AM - Matthias Kuhn

Pull request to change selection / current edited feature style in pipeline:

Please let me know what you think about this once it's merged.

https://github.com/qgis/Quantum-GIS/pull/508

#7 - 2013-04-08 07:03 PM - Mathieu Pellerin - nIRV

Matthias, ahh, this is a million times better :) the new selection mechanism feels much more natural, and item click equals bring up form is exactly how it

should behave. And the whole thing feels much faster too.

Two little issues:

- in the dual view mode, the list should sort itself out based on column preview of expression-based strings (or if an id based on its incremental order). 

- right now, when switching to dual view mode, the left-side list is displaying nothing as it's relying on an empty expression; there could be simple logic

applied here to offer a better experience. I.e. by default, it should use a column, and it could look into columns with 'id' or 'name' to use as default, otherwise

fallback to first column.

Cheers

#8 - 2013-04-08 11:07 PM - Matthias Kuhn
nice you like it.

Concerning the issues:

- sorting should be sorted out, agreed

- right now, the logic for the default display expression is (in this order of preference):  * use the display field from the layer properties tab  * use primary

key(s)  * concat all fields seperated by ','

For any of the options, if there is a problem with the produced expression (e.g. empty attribute name) or there is a NULL expression in one of the involved

fields, the result is empty as well. (The first one will even spit out a warning)

At least of the second one, I should take care of, agreed.

#9 - 2013-04-08 11:08 PM - Matthias Kuhn

- Status changed from Feedback to Closed

Files

layout_attribute_table.jpg 28.2 KB 2013-04-03 Regis Haubourg
